/* ADCS Example Files */
/* (c) 2019 National Instruments */

#ifndef LIBNIDIAGCS_ENUMS_H
#define LIBNIDIAGCS_ENUMS_H

/* Properties */
#define ADCS_PROPERTY_TIMEOUT_DIAG_COMMAND 0
#define ADCS_PROPERTY_TIMEOUT_FC 1
#define ADCS_PROPERTY_TIMEOUT_CF 2
#define ADCS_PROPERTY_RECEIVE_BLOCK_SIZE 3
#define ADCS_PROPERTY_WAIT_TIME_CF 4
#define ADCS_PROPERTY_MAX_WAIT_FRAMES 5
#define ADCS_PROPERTY_WAIT_FRAMES_TO_SEND 6
#define ADCS_PROPERTY_TIME_BETWEEN_WAITS 7
#define ADCS_PROPERTY_FILL_CAN_FRAMES 8
#define ADCS_PROPERTY_FILL_BYTE 9
#define ADCS_PROPERTY_INVALID_RESPONSE_AS_ERROR 10
#define ADCS_PROPERTY_MAX_RSPPENDING_COUNT 11
#define ADCS_PROPERTY_VWTP_COMMAND_TIME_OUT 12
#define ADCS_PROPERTY_STMIN_LIN 13
#define ADCS_PROPERTY_P2MIN_LIN 14
#define ADCS_PROPERTY_TERMINATION 15
#define ADCS_PROPERTY_TIMEOUT_RSPPENDING 16
#define ADCS_PROPERTY_LIN_SLEEP 17
#define ADCS_PROPERTY_ACTUAL_CAN_IO_MODE 18
#define ADCS_PROPERTY_RESPONSE_PLAUSIBILITY_CHECK 19
#define ADCS_PROPERTY_SESSION_BASED_PROPERTIES 20

/* Additional standard property names, redefined for ease of use */
#define ADCS_PROPERTY_BS ADCS_PROPERTY_TIMEOUT_FC
#define ADCS_PROPERTY_BR ADCS_PROPERTY_TIME_BETWEEN_WAITS
#define ADCS_PROPERTY_CR ADCS_PROPERTY_TIMEOUT_CF
#define ADCS_PROPERTY_P2MAX ADCS_PROPERTY_TIMEOUT_DIAG_COMMAND
#define ADCS_PROPERTY_P2STAR ADCS_PROPERTY_TIMEOUT_RSPPENDING
#define ADCS_PROPERTY_STMIN ADCS_PROPERTY_WAIT_TIME_CF
#define ADCS_PROPERTY_N_WAIT ADCS_PROPERTY_WAIT_FRAMES_TO_SEND
#define ADCS_PROPERTY_N_WFTMAX ADCS_PROPERTY_MAX_WAIT_FRAMES



/* Adressing Modes */
#define ADCS_ADRESSINGMODE_PHYSICAL 0
#define ADCS_ADRESSINGMODE_FUNCTIONAL 1

/* Byte Order */
#define ADCS_BYTEORDER_MOTOROLA 0
#define ADCS_BYTEORDER_INTEL 1

/* Data Types */
#define ADCS_DATATYPE_UNSIGNED 0
#define ADCS_DATATYPE_SIGNED 1
#define ADCS_DATATYPE_FLOAT 2

/* DTC Status Bits */
#define ADCS_DTCSTATUSBIT_TEST_FAILED 0
#define ADCS_DTCSTATUSBIT_TEST_FAILED_THIS_MONITORING_CYCLE 1
#define ADCS_DTCSTATUSBIT_PENDING_DTC 2
#define ADCS_DTCSTATUSBIT_CONFIRMED_DTC 3
#define ADCS_DTCSTATUSBIT_TEST_NOT_COMPLETED_SINCE_LAST_CLEAR 4
#define ADCS_DTCSTATUSBIT_TEST_FAILED_SINCE_LAST_CLEAR 5
#define ADCS_DTCSTATUSBIT_TEST_NOT_COMPLETED_THIS_MONITORING_CYCLE 6
#define ADCS_DTCSTATUSBIT_WARNING_INDICATOR_REQUESTED 7

/* CAN I/O Modes */
#define ADCS_IOMODE_CAN_20 0
#define ADCS_IOMODE_CAN_FD 1
#define ADCS_IOMODE_CAN_FD_BRS 2
#define ADCS_IOMODE_ECU_DETERMINED 3

/* Transport Protocols */
#define ADCS_TP_ISOTP_NORMAL 0
#define ADCS_TP_ISOTP_MIXED 1
#define ADCS_TP_VWTP20 2
#define ADCS_TP_DOIP 3
#define ADCS_TP_ISOTP_LIN 4

/* Periodic TesterPresent Message Types */
#define ADCS_TESTERPRESENT_MESSAGETYPE_KWP2000 0
#define ADCS_TESTERPRESENT_MESSAGETYPE_UDS 1
#define ADCS_TESTERPRESENT_MESSAGETYPE_USER_DEFINED 2



/* UDS DTC Setting Types */
#define ADCS_UDS_DTCSETTINGTYPE_ON 1
#define ADCS_UDS_DTCSETTINGTYPE_OFF 2

/* UDS Communication Control Communication Types */
#define ADCS_UDS_COMUNICATIONCONTROLCOMMTYPEFLAG_APPLICATION 1
#define ADCS_UDS_COMUNICATIONCONTROLCOMMTYPEFLAG_NETWORK_MANAGEMENT 2

/* UDS Communication Control Types */
#define ADCS_UDS_COMUNICATIONCONTROLTYPE_ENABLE_RX_AND_ENABLE_TX 0
#define ADCS_UDS_COMUNICATIONCONTROLTYPE_ENABLE_RX_AND_DISABLE_TX 1
#define ADCS_UDS_COMUNICATIONCONTROLTYPE_DISABLE_RX_AND_ENABLE_TX 2
#define ADCS_UDS_COMUNICATIONCONTROLTYPE_DISABLE_RX_AND_DISABLE_TX 3

/* UDS DTC Groups */
#define ADCS_UDS_DTCGROUP_ALL_DTCS 0xFFFF

/* UDS ECU Reset Modes */
#define ADCS_UDS_ECURESETMODE_HARD_RESET 1
#define ADCS_UDS_ECURESETMODE_KEY_OFF_ON_RESET 2
#define ADCS_UDS_ECURESETMODE_SOFT_RESET 3
#define ADCS_UDS_ECURESETMODE_ENABLE_RAPID_POWER_SHUTDOWN 4
#define ADCS_UDS_ECURESETMODE_DISABLE_RAPID_POWER_SHUTDOWN 5

/* UDS I/O Control Types */
#define ADCS_UDS_IOCONTROLMODE_RETURN_CONTROL_TO_ECU 0
#define ADCS_UDS_IOCONTROLMODE_RESET_TO_DEFAULT 1
#define ADCS_UDS_IOCONTROLMODE_FREEZE_CURRENT_STATE 2
#define ADCS_UDS_IOCONTROLMODE_SHORT_TERM_ADJUSTMENT 3

/* UDS Routine Control Modes */
#define ADCS_UDS_ROUTINECONTROLMODE_START 1
#define ADCS_UDS_ROUTINECONTROLMODE_STOP 2
#define ADCS_UDS_ROUTINECONTROLMODE_REQUEST_RESULTS 3

/* UDS Diagnostic Sessions */
#define ADCS_UDS_SESSIONMODE_DEFAULT_SESSION 1
#define ADCS_UDS_SESSIONMODE_PROGRAMMING_SESSION 2
#define ADCS_UDS_SESSIONMODE_EXTENDED_DIAGNOSTIC_SESSION 3



/* WWH-OBD DID Types */
#define ADCS_WWHOBD_DID_PID 0
#define ADCS_WWHOBD_DID_MID 1
#define ADCS_WWHOBD_DID_ITID 2

/* WWH-OBD Routine Control Modes */
#define ADCS_WWHOBD_ROUTINECONTROLMODE_START 1
#define ADCS_WWHOBD_ROUTINECONTROLMODE_STOP 2
#define ADCS_WWHOBD_ROUTINECONTROLMODE_REQUEST_RESULTS 3




/* KWP2000 DTC Groups */
#define ADCS_KWP2000_DTCGROUP_ALL_POWERTRAIN_DTCS 0x0000
#define ADCS_KWP2000_DTCGROUP_ALL_CHASSIS_DTCS 0x4000
#define ADCS_KWP2000_DTCGROUP_ALL_BODY_DTCS 0x8000
#define ADCS_KWP2000_DTCGROUP_ALL_NETWORK_RELATED_DTCS 0xC000
#define ADCS_KWP2000_DTCGROUP_ALL_DTCS 0xFF00

/* KWP2000 ECU Reset Modes */
#define ADCS_KWP2000_ECURESETMODE_POWERON 1
#define ADCS_KWP2000_ECURESETMODE_POWERON_WHILE_MAINTAINING_COMMUNICATION 2

/* KWP2000 I/O Control Modes */
#define ADCS_KWP2000_IOCONTROLMODE_RETURN_CONTROL_TO_ECU 0
#define ADCS_KWP2000_IOCONTROLMODE_REPORT_CURRENT_STATE 1
#define ADCS_KWP2000_IOCONTROLMODE_RESET_TO_DEFAULT 4
#define ADCS_KWP2000_IOCONTROLMODE_FREEZE_CURRENT_STATE 5
#define ADCS_KWP2000_IOCONTROLMODE_SHORT_TERM_ADJUSTMENT 7
#define ADCS_KWP2000_IOCONTROLMODE_LONG_TERM_ADJUSTMENT 8



/* DoIP Routing Activation Types */
#define ADCS_ACTIVATIONTYPE_DEFAULT 0
#define ADCS_ACTIVATIONTYPE_WWHOBD 1

/* DoIP Node Types */
#define ADCS_DOIP_NODETYPE_GATEWAY 0
#define ADCS_DOIP_NODETYPE_NODE 1

/* DoIP Get Entities Open Type */
#define ADCS_DOIP_OPENTYPE_VIN 0
#define ADCS_DOIP_OPENTYPE_EID 1
#define ADCS_DOIP_OPENTYPE_ALL 2

/* DoIP Power Modes */
#define ADCS_DOIP_POWERMODE_NOTREADY 0
#define ADCS_DOIP_POWERMODE_READY 1

/* DoIP Protocol Versions */
#define ADCS_DOIP_VERSION_DIS_13400_2_2010 1
#define ADCS_DOIP_VERSION_ISO_13400_2_2012 2



/* VWTP Application Types */
#define ADCS_VWTP_APPLICATIONTYPE_KWP2000 1
#define ADCS_VWTP_APPLICATIONTYPE_KS_TYPE_010C 2
#define ADCS_VWTP_APPLICATIONTYPE_INFOTAINMENT_COMMUNICATION 16
#define ADCS_VWTP_APPLICATIONTYPE_APPLICATION_PROTOCOL 32
#define ADCS_VWTP_APPLICATIONTYPE_WFS_WIV 33

#endif /* LIBNIDIAGCS_ENUMS_H */
